KDE 4.9 PyKDE API Reference

- KDE's Python API

# KAbstractFileWidget Class Reference

`from PyKDE4.kio import *`

Subclasses: KFileWidget

## Detailed Description

Base class for KFileWidget.

This abstract interface allows KFileDialog (in kio) to call methods on the dlopened KFileWidget (from kfilemodule.so)

In addition to the pure virtual methods defined below, the implementations of KAbstractFileWidget are expected to define the following signals: <ul> <li>fileSelected(const KUrl&)</li> <li>fileHighlighted(const KUrl&)</li> <li>selectionChanged()</li> <li>filterChanged(const QString&)</li> <li>accepted()</li> </ul>

## Enumerations

OperationMode | { Other, Opening, Saving }

## Methods

| accept (self)
KActionCollection | actionCollection (self)
KUrl | baseUrl (self)
KPushButton | cancelButton (self)
| clearFilter (self)
QString | currentFilter (self)
KSharedPtr<KMimeType> | currentFilterMimeType (self)
QString | currentMimeFilter (self)
KFileFilterCombo | filterWidget (self)
bool | keepsLocation (self)
KUrlComboBox | locationEdit (self)
KFile.Modes | mode (self)
KPushButton | okButton (self)
KAbstractFileWidget.OperationMode | operationMode (self)
QString | selectedFile (self)
QStringList | selectedFiles (self)
KUrl | selectedUrl (self)
KUrl.List | selectedUrls (self)
| setConfirmOverwrite (self, bool enable)
| setCustomWidget (self, QWidget widget)
| setCustomWidget (self, QString text, QWidget widget)
| setFilter (self, QString filter)
| setInlinePreviewShown (self, bool show)
| setKeepLocation (self, bool keep)
| setLocationLabel (self, QString text)
| setMimeFilter (self, QStringList types, QString defaultType=QString())
| setMode (self, KFile.Modes m)
| setOperationMode (self, KAbstractFileWidget.OperationMode a0)
| setPreviewWidget (self, KPreviewWidgetBase w)
| setSelection (self, QString name)
| setUrl (self, KUrl url, bool clearforward=1)
| slotCancel (self)
| slotOk (self)
KToolBar | toolBar (self)
| virtual_hook (self, int id, void data)

## Method Documentation

accept | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

KActionCollection actionCollection | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  a pointer to the action collection, holding all the used KActions.

KUrl baseUrl | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  the currently shown directory.

KPushButton cancelButton | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  a pointer to the Cancel-Button in the filedialog. Note that the button is hidden and unconnected when using KFileWidget alone; KFileDialog shows it and connects to it.

clearFilter | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Clears any mime- or namefilter. Does not reload the directory.

QString currentFilter | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns the current filter as entered by the user or one of the predefined set via setFilter().

See also:
  setFilter()

See also:
  filterChanged()

KSharedPtr<KMimeType> currentFilterMimeType | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns the mimetype for the desired output format.

This is only valid if setFilterMimeType() has been called previously.

See also:
  setFilterMimeType()

QString currentMimeFilter | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

The mimetype for the desired output format.

This is only valid if setMimeFilter() has been called previously.

See also:
  setMimeFilter()

KFileFilterCombo filterWidget | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  the combobox that contains the filters

bool keepsLocation | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  whether the contents of the location edit are kept when changing directories.

KUrlComboBox locationEdit | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  the combobox used to type the filename or full location of the file.

KFile.Modes mode | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns the mode of the filedialog.

See also:
  setMode()

KPushButton okButton | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  a pointer to the OK-Button in the filedialog. Note that the button is hidden and unconnected when using KFileWidget alone; KFileDialog shows it and connects to it.

KAbstractFileWidget.OperationMode operationMode | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  the current operation mode, Opening, Saving or Other. Default is Other.

See also:
  operationMode

See also:
  KFileDialog.OperationMode

QString selectedFile | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns the full path of the selected file in the local filesystem. (Local files only)

QStringList selectedFiles | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns a list of all selected local files.

KUrl selectedUrl | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  The selected fully qualified filename.

KUrl.List selectedUrls | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns:
  The list of selected URLs.

setConfirmOverwrite | ( | self, |
|  | bool | enable
| ) |  |  |

Sets whether the user should be asked for confirmation when an overwrite might occurr.

Parameters:

  | enable | Set this to true to enable checking.

Since:
  4.2

setCustomWidget | ( | self, |
|  | QWidget | widget
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets a custom widget that should be added below the location and the filter editors.

Parameters:

  | text | Label of the custom widget, which is displayed below the labels "Location:" and "Filter:".
  | widget | Any kind of widget, but preferable a combo box or a line editor to be compliant with the location and filter layout. When creating this widget, you don't need to specify a parent, since the widget's parent will be set automatically by KFileWidget.

setCustomWidget | ( | self, |
|  | QString | text,
|  | QWidget | widget
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets a custom widget that should be added below the location and the filter editors.

Parameters:

  | text | Label of the custom widget, which is displayed below the labels "Location:" and "Filter:".
  | widget | Any kind of widget, but preferable a combo box or a line editor to be compliant with the location and filter layout. When creating this widget, you don't need to specify a parent, since the widget's parent will be set automatically by KFileWidget.

setFilter | ( | self, |
|  | QString | filter
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the filter to be used to filter.

You can set more filters for the user to select separated by '\n'. Every filter entry is defined through namefilter|text to display. If no | is found in the expression, just the namefilter is shown. Examples:

     kfile->setFilter("*.cpp|C++ Source Files\n*.h|Header files");
     kfile->setFilter("*.cpp");
     kfile->setFilter("*.cpp|Sources (*.cpp)");
     kfile->setFilter("*.cpp|" + i18n("Sources (*.cpp)"));
     kfile->setFilter("*.cpp *.cc *.C|C++ Source Files\n*.h *.H|Header files");

Note: The text to display is not parsed in any way. So, if you want to show the suffix to select by a specific filter, you must repeat it.

If the filter contains an unescaped '/', a mimetype-filter is assumed. If you would like a '/' visible in your filter it can be escaped with a '\'. You can specify multiple mimetypes like this (separated with space):

     kfile->setFilter( "image/png text/html text/plain" );
     kfile->setFilter( "*.cue|CUE\\/BIN Files (*.cue)" );

See also:
  filterChanged

See also:
  setMimeFilter

setInlinePreviewShown | ( | self, |
|  | bool | show
| ) |  |  |

Forces the inline previews to be shown or hidden, depending on show.

Parameters:

  | show | Whether to show inline previews or not.

Since:
  4.2

setKeepLocation | ( | self, |
|  | bool | keep
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets whether the filename/url should be kept when changing directories. This is for example useful when having a predefined filename where the full path for that file is searched.

This is implicitly set when operationMode() is KFileDialog.Saving

getSaveFileName() and getSaveUrl() set this to true by default, so that you can type in the filename and change the directory without having to type the name again.

setLocationLabel | ( | self, |
|  | QString | text
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the text to be displayed in front of the selection.

The default is "Location". Most useful if you want to make clear what the location is used for.

setMimeFilter | ( | self, |
|  | QStringList | types,
|  | QString | defaultType=QString()
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the filter up to specify the output type.

Parameters:

  | types | a list of mimetypes that can be used as output format
  | defaultType | the default mimetype to use as output format, if any. If defaultType is set, it will be set as the current item. Otherwise, a first item showing all the mimetypes will be created. Typically, defaultType should be empty for loading and set for saving.

Do not use in conjunction with setFilter()

setMode | ( | self, |
|  | KFile.Modes | m
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the mode of the dialog.

The mode is defined as (in kfile.h):

        enum Mode {
             File         = 1,
             Directory    = 2,
             Files        = 4,
             ExistingOnly = 8,
             LocalOnly    = 16
        };

You can OR the values, e.g.

     KFile.Modes mode = KFile.Files |
                         KFile.ExistingOnly |
                         KFile.LocalOnly );
     setMode( mode );

setOperationMode | ( | self, |
|  | KAbstractFileWidget.OperationMode | a0
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the operational mode of the filedialog to Saving, Opening or Other. This will set some flags that are specific to loading or saving files. E.g. setKeepLocation() makes mostly sense for a save-as dialog. So setOperationMode( KFileDialog.Saving ); sets setKeepLocation for example.

The mode Saving, together with a default filter set via setMimeFilter() will make the filter combobox read-only.

The default mode is Opening.

Call this method right after instantiating KFileDialog.

See also:
  operationMode

See also:
  KFileDialog.OperationMode

setPreviewWidget | ( | self, |
|  | KPreviewWidgetBase | w
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Adds a preview widget and enters the preview mode.

In this mode the dialog is split and the right part contains your preview widget.

Ownership is transferred to KFileDialog. You need to create the preview-widget with "new", i.e. on the heap.

Parameters:

  | w | The widget to be used for the preview.

setSelection | ( | self, |
|  | QString | name
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the file name to preselect to name

This takes absolute URLs and relative file names.

setUrl | ( | self, |
|  | KUrl | url,
|  | bool | clearforward=1
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Sets the directory to view.

Parameters:

  | url | URL to show.
  | clearforward | Indicates whether the forward queue should be cleared.

slotCancel | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

slotOk | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Called when clicking ok (when this widget is used in KFileDialog) Might or might not call accept().

KToolBar toolBar | ( |  | self ) |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Returns a pointer to the toolbar.

You can use this to insert custom items into it, e.g.:

          yourAction = new KAction( i18n("Your Action"), 0,
                                    this, SLOT( yourSlot() ),
                                    this, "action name" );
          yourAction->plug( kfileDialog->toolBar() );

virtual_hook | ( | self, |
|  | int | id,
|  | void | data
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

## Enumeration Documentation

OperationMode

Defines some default behavior of the filedialog. E.g. in mode Opening and Saving, the selected files/urls will be added to the "recent documents" list. The Saving mode also implies setKeepLocation() being set.

Other means that no default actions are performed.

See also:
  setOperationMode

See also:
  operationMode

Enumerator:

  Other = 0 |
  Opening |
  Saving |